<template name="CategoriesEditor">
  <div class="categories-manager">
    <h1>Categories</h1>
    {{#each categories }}
      <div>
        {{> CategoryRow }}
        <span>
          {{> CategoryBindableValuesEditor}}
          {{> ArticleDefaultsEditor }}
        </span>
      </div>
    {{/each}}
    {{> CategoryForm}}
  </div>
</template>

<template name="CategoryRow">
  <span>
    {{#unless articlesCount}}
      <button type="button" name="remove" data-action="remove-category">&times;</button>
    {{/unless}}
    {{ name }}<br>
    <span class="articles-count">
      articles count : {{ articlesCount }}
    </span>
  </span>
</template>

<template name="CategoryForm">
  <form data-action="create-category">
    <p>
      <input type="text" name="name" required>
      <input type="submit" value="Add category">
    </p>
  </form>
</template>

<template name="CategoryBindableValuesEditor">
  <ul class="bindable-values">
    {{#each bindableValues}}
      {{> CategoryBindableValueLine}}
    {{/each}}
  </ul>
  <form data-action="add-bindable-value">
    <p>
      <input type="text" name="bindable-value" required>
      <input type="submit" value="Add bindable value">
    </p>
  </form>
</template>

<template name="CategoryBindableValueLine">
  <li>
    {{ this }}
    <button type="button" name="remove" data-action="remove-bindable-value">&times;</button>
  </li>
</template>

<template name="ArticleDefaultsEditor">
  <span>
    <p>
      <button data-view-action="toggle-article-defaults">
        Toggle article defaults
      </button>
    </p>
    <ul class="hidden-by-default article-defaults">
      {{#if technicalsAreAvailable}}
        <form data-action="add-technical-property">
          <select name="technical-property">
            {{#each technicals}}
              <option value="{{ name }}">{{ name }}</option>
            {{/each}}
          </select>
          <input type="text" name="technical-value" required>
          <input type="submit" value="Add default value">
        </form>
      {{/if}}
      {{#each articleDefaults.technicals}}
        {{> ArticleDefaultsTechnicalLineEditor}}
      {{/each}}
    </ul>
  </span>
</template>

<template name="ArticleDefaultsTechnicalLineEditor">
  <li>
    <label for="technical-property">{{ name }} </label>
    <input type="text" name="technical-property" value="{{ value }}" data-action="update-technical-property">
    <button type="button" name="remove" data-action="remove-technical-property">&times;</button>
  </li>
</template>
